from setuptools import setup, find_packages

setup(
    name="SynthTextEval",  # Replace with your package name
    version="1.1.1",
    description="SynthTextEval is an open-source library built to enable comprehensive evaluation of synthetic text generated by large language models (LLMs). It supports the evaluation of synthetic text by considering its downstream utility, fairness, privacy preservation, and automated text quality evaluation, along with functionality for both descriptive and visual data analysis and synthetic text generation with differential privacy.",
    author="Krithika Ramesh, Daniel Smolyak, Zihao Zhao, Nupoor Gandhi",
    author_email="kramesh3@jh.edu, dsmolyak@gmail.com, zzhao71@jhu.edu, nmgandhi@cs.cmu.edu",
    url="https://github.com/kr-ramesh/synthtexteval",  # Replace with your URL
    packages=find_packages(),
    include_package_data=True,
    install_requires=[  # Add dependencies here
        "numpy",
        "pandas",
        "datasets",
        "evaluate",
        "GitPython",
        "matplotlib",
        "seaborn",
        "mauve_text",
        "scikit_learn",
        "scipy",
        "sentence_transformers",
        "setuptools",
        "spacy",
        "torch",
        "tqdm",
        "transformers",
        "opacus",
        "rouge_score",
        "pynvml",
        "prv-accountant",
        "tabulate",
        "pyldavis",
        "IPython",
    ],
    classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
    ],
    python_requires=">=3.9",
)